package applications.dns;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.sql.*;
import java.io.*;
import javax.swing.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JPanel; 
import javax.swing.JFrame;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.awt.datatransfer.*;
import java.lang.reflect.*;
import applications.basics.DBcomboBox;

public class GenerateServer extends JPanel {

    private DBcomboBox domain;
    private String soa, db,rev,lochost, boot, conf;
    private DomainRow zone;
    public JButton close;
    public JPanel infoPanel;
    public JLabel info;
    private JCheckBox intoFile, doCache, doForwarder;
    
    String directory;
    
    /**
       * Get the value of directory.
       * @return Value of directory.
       */
    public String getDirectory() {return directory;}
    
    /**
       * Set the value of directory.
       * @param v  Value to assign to directory.
       */
    public void setDirectory(String  v) {this.directory = v;}
    
    String host;

    
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getHost() {return host;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host.
       */
    public void setHost(String  v) {this.host = v;}
    
    
    String user;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getUser() {return user;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setUser(String  v) {this.user = v;}
    
    
    
    String password;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getPassword() {return password;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setPassword(String  v) {this.password = v;}
    
    
    String database;
    
    /**
       * Get the value of database.
       * @return Value of database.
       */
    public String getDatabase() {return database;}
    
    /**
       * Set the value of database.
       * @param v  Value to assign to database.
       */
    public void setDatabase(String  v) {this.database = v;}


    private String getForwarders() {


	System.out.println("Domain = " + zone.getName());

	String fw3 = "";


	ForwarderRow fw = new ForwarderRow(this.getHost(),this.getUser(),this.getPassword());
	ForwarderRow fw2= new ForwarderRow(this.getHost(),this.getUser(),this.getPassword());

        fw.searchByDomain(zone.getName(),false);
        fw2 = fw.next();
	fw3 = fw3 + fw2.getHostname();
	while (fw2 != null ) {
          fw2 = fw.next();
	  if (fw2 != null)  fw3 = fw3 + "; " + fw2.getHostname();
	}
	return fw3;
    }


    public GenerateServer(String host, String user, String password) {

	setHost(host);
	setUser(user);
	setPassword(password);
	setDatabase("dns");

	infoPanel = new JPanel();
	this.setLayout(new BorderLayout());
	infoPanel.setLayout(new FlowLayout());
	infoPanel.add(new JLabel("Domain"));
	
	domain = new DBcomboBox(getHost(),getUser(),getPassword(),"dns","select name from domain order by name");	
	domain.setSelectedIndex(0);
	infoPanel.add(domain);

        JPanel genPanel = new JPanel();
	genPanel.setLayout(new GridLayout(0,1));


	intoFile = new JCheckBox("into File");
	intoFile.setSelected(false);
	intoFile.setToolTipText("makes sense if not done out of a browser");
	genPanel.add(intoFile);


	doCache = new JCheckBox("enable Cache");
	doCache.setSelected(true);
	doCache.setToolTipText("enables Cachefunction");
	genPanel.add(doCache);

	doForwarder = new JCheckBox("Forewarder");
	doForwarder.setSelected(true);
	doForwarder.setToolTipText("activate forwarder");
	genPanel.add(doForwarder);




	infoPanel.add(genPanel);


	JButton generate = new JButton("Generate");
	generate.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		if (intoFile.isSelected() ) {
		    selectDirectory();
		} else { justDoIt(); }
		}});
	infoPanel.add(generate);

        close = new JButton("close");
	infoPanel.add(close);


	info = new JLabel("Fredy's DNS-Tool");
	this.add("Center",infoPanel);
        this.add("South",info);
    }

	private void justDoIt() {

	    infoPanel.setCursor(new Cursor(Cursor.WAIT_CURSOR));

	    // read in the Domain
	    zone = new DomainRow(getHost(),getUser(),getPassword());
	    String dn = (String)domain.getSelectedItem();

	    zone.searchByName(dn,true);
	    zone = zone.next();
	    zone.setSerialnumber(zone.getSerialnumber() + 1);
	    zone.update();

	    // 1. Step: generate Header-File
	    
	    soa =       "@		IN	SOA	" + fullyQualified(zone.getName()) + "	    " + zone.getResponsible() + "." + fullyQualified(zone.getName()) + " (\n\n";
	    soa = soa + "				" + Integer.toString(zone.getSerialnumber()) + "\t; Serial Number\n";
	    soa = soa + "				" + Integer.toString(zone.getRefresh()) + "\t; refresh (the following lines are seconds)\n";
	    soa = soa + "				" + Integer.toString(zone.getRetry()) + "\t; retry\n";
	    soa = soa + "				" + Integer.toString(zone.getExpire()) + "\t; expiry\n";	    
	    soa = soa + "				" + Integer.toString(zone.getMinTTL()) + " )\t; minimum TTL\n\n";

	    // 2. Step: add Nameserver

	    db = soa + "\n;\n; Name server\n;\n";
	    NameserverRow ns  = new NameserverRow(getHost(), getUser(), getPassword());
	    NameserverRow ns2 = new NameserverRow(getHost(), getUser(), getPassword());

	    ns.searchByDomain(zone.getName(),true);
	    ns2 = ns.next();
	    while (ns2 != null) {
		db = db + "				NS	" + fullyQualified(ns2.getNameserver()) + "\n";
		ns2 = ns.next();
		
	    }

	    // Mailexchange
	    db = db + "\n;\n; Mailserver\n;\n";
	    MailexchangeRow mxr = new MailexchangeRow(getHost(), getUser(), getPassword());
	    MailexchangeRow mxr2 = new MailexchangeRow(getHost(), getUser(), getPassword());
	    mxr.searchByDomain(zone.getName(),true);
	    mxr2 = mxr.next();
	    while (mxr2 != null) {
		db = db + "				MX " + mxr2.getPriority() + " "  + fullyQualified(mxr2.getMailexchange()) + "\n";
		mxr2 = mxr.next();
		
	    }
	    
	    rev      = db;
	    rev      = db + ";\n; Addresses point to canonical name\n;\n";
	    lochost  = db + "\n1             PTR     localhost.\n";

	    // 3. Step: create the DB-File
	    db = db + ";\n; localhost and exit-code\n;\n";

	    db = db + "\n" +
		"localhost			A	127.0.0.1\n" +
                "use.exit.to.leave.nslookup.-.-.-	CNAME	localhost\n" +
                "quit				CNAME	use.exit.to.leave.nslookup.-.-.-\n\n";

	    // 4. Step: add Host-Records to the DB-file
	    db = db + ";\n; Addresses for the canonical names\n;\n";

	    HostRow hr = new HostRow(getHost(), getUser(), getPassword());
	    HostRow hx = new HostRow(getHost(), getUser(), getPassword());

	    hr.searchByDomain(zone.getName(),true);
	    hx = hr.next();
	    while (hx != null) {
		db = db + fullyQualified(hx.getHostname()) + "\t\tA\t" + hx.getIp() + "\n";

		// as we are here adding the hostinformation-Records for this host
		HostinformationRow hir  = new HostinformationRow(getHost(), getUser(), getPassword());
		HostinformationRow hir2 = new HostinformationRow(getHost(), getUser(), getPassword());
		hir.searchHostsInDomain(zone.getName(),hx.getHostname(),true);
		hir2 = hir.next();
		if (hir2 != null) {
		while (hir2 != null) {
		    db = db + "\t\t\tHINFO\t\"" + hir2.getHardware() + "\" \"" + hir2.getOs() + "\"\n";
		    hir2 = hir.next();   
		}
		}

		// as we are here adding the WKS-Records for this host
		if ( hx.getWksTCP().length() > 1 ) db = db + "\t\t\tWKS\t" + hx.getIp() + " TCP " + hx.getWksTCP() + "\n";
		if ( hx.getWksUDP().length() > 1 ) db = db + "\t\t\tWKS\t" + hx.getIp() + " UDP " + hx.getWksUDP() + "\n";
		

		//	rev = rev + getLastToken(hx.getIp()) + ".in-addr.arpa.\t PTR " +fullyQualified(hx.getHostname()) + "\n";
		rev = rev + getLastToken(hx.getIp()) + "\t\t PTR " +fullyQualified(hx.getHostname()) + "\n";
		hx = hr.next();

	    }
	    db = db + "\n";

	    // Step 5: Aliases
	    db = db + ";\n; Aliases\n;\n";
	    AliasRow ar = new AliasRow(getHost(),getUser(),getPassword());
	    AliasRow ax = new AliasRow(getHost(),getUser(),getPassword());
	    ar.searchByDomain(zone.getName(),true);
	    ax = ar.next();
	    while (ax != null) {
		db = db + ax.getHostname() + "\t\tCNAME\t" + fullyQualified(ax.getHostname()) + "\n";
		ax = ar.next();
	    }
	    db = db + "\n";


	    // Step 6: create named.boot
	    boot = "DIRECTORY\t/var/named\n" +
                   "PRIMARY\t" + fullyQualified(zone.getName()) + "\t\tdb." + zone.getName() + "\n" +
		   "PRIMARY\t" + reverser(zone.getNetwork()) + ".in-addr.arpa\tdb." + zone.getNetwork() + "\n" +
		   "PRIMARY\t" + "0.0.127.in-addr.arpa\tdb.127.0.0\n";

	    // Step 7: create named.conf
	    conf = "options {\n" +
		   "        directory    \"/var/named\";\n";

	    if (doForwarder.isSelected()) {
	    conf = conf +
                   "        forward only;\n" +
		   "        forwarders { " + getForwarders() + " }; \n";
	    }

	    conf = conf +
		   "};\n\n";
	    if (doCache.isSelected()) {
	    conf = conf + 
		  "zone \".\" in {\n" +
		  "         type master;\n" +
		  "         file \"db.cache\";\n};\n\n";
	    }

	    conf = conf +
		   "zone \"" + fullyQualified(zone.getName()) + "\" in {\n" +
		   "        type master;\n" +
		   "        file \"db." + zone.getName() + "\";\n};\n\n" +
		   "zone \"" + reverser(zone.getNetwork()) + ".in-addr.arpa\" in {\n" +
		   "        type master;\n" +
		   "        file \"db." + zone.getNetwork() + "\";\n};\n\n" +
		   "zone \"0.0.127.in-addr.arpa\" in {\n" +
		   "        type master;\n" +
		   "        file \"db.127.0.0\";\n};\n";


	    // Step 8: Write all
	    if ( ! intoFile.isSelected()) {
		DnsFile df1 = new DnsFile("db." + zone.getName(),db);
		DnsFile df2 = new DnsFile("db." + zone.getNetwork(),rev);
		DnsFile df3 = new DnsFile("db.127.0.0",lochost);
		DnsFile df4 = new DnsFile("named.boot",boot);
		DnsFile df5 = new DnsFile("named.conf",conf);


	    } else {
	    saveFile(db, "db." + zone.getName());
	    saveFile(rev,"db." + zone.getNetwork());
	    saveFile(lochost,"db.127.0.0");
	    saveFile(boot,"named.boot");
	    saveFile(conf,"named.conf");

	    info.setText("Created Domain " + zone.getName());
	    }
	    infoPanel.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));


	       
	}
 


    private void saveFile(String text, String file) {

	String dnsFile = getDirectory() + File.separator + file;
	try {
	      	DataOutputStream outptstr = new DataOutputStream(
		     new BufferedOutputStream(
		     new FileOutputStream(dnsFile)));
			 outptstr.writeBytes(text);
			 outptstr.flush();
			 outptstr.close();
	}	catch(IOException execp) { message(execp.toString()); }


    }


    private void selectDirectory() {

	JFileChooser chooser = new JFileChooser(); 
	chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	chooser.setDialogTitle("Choose Directory");
	
	int returnVal = chooser.showOpenDialog(this);
	if(returnVal == JFileChooser.APPROVE_OPTION) {
	    setDirectory(chooser.getCurrentDirectory() + File.separator + chooser.getSelectedFile().getName());
	    Thread t = new Thread() {
		public void run() {	
		    justDoIt();
		}
	    };
	    t.start();

	}


    }

    private void message(String msg) {

	System.out.println(msg);

    }

	private String fullyQualified(String n) {

	    if (n.endsWith(".")) {
		return n;
	    } else {
		if (n.endsWith(zone.getName()) ) {
		    return n + ".";
		} else {
		    if (n.indexOf(".") > -1 ) { // probably another domain
			return n + ".";
		    } else {
			return n + "." + zone.getName() + ".";
		    }
		}
	    }
	}


    private String getLastToken(String n) {

	String s = "";
	StringTokenizer st = new StringTokenizer(n,".");
	while (st.hasMoreTokens()) {
	    s = st.nextToken();	    
        } 
	return s;
    }


    private String reverser(String n) {
	StringTokenizer st = new StringTokenizer(n,".");
	Vector v = new Vector();
	String revVal = null;
	while (st.hasMoreTokens()) {
	    v.addElement(st.nextToken());	    
        } 
        for (int j = 1; j <= v.size() ; j++ ) {
	    if (revVal == null ) {
		revVal = (String)v.elementAt(v.size() - j);
	    } else {
		revVal = revVal + "." + (String)v.elementAt(v.size() - j);
	    }
	}    
	return revVal;
    }

        public static void main(String args[]) {
	    if (args.length != 3 ) {
		System.out.println("Syntax: java applications.dns.GenerateServer host user password");
		System.exit(0);
	    }
	    JFrame frame = new JFrame("Generate Server");
	    GenerateServer gs = new GenerateServer(args[0],args[1],args[2]);
	    frame.getContentPane().add(gs);
	    frame.pack();
	    frame.setVisible(true);
	    gs.close.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    System.exit(0);
		    }});
	    frame.addWindowListener(new WindowAdapter() {
		public void windowActivated(WindowEvent e) {}
		public void windowClosed(WindowEvent e) {}
		public void windowClosing(WindowEvent e) {System.exit(0);}
		public void windowDeactivated(WindowEvent e) {}
		public void windowDeiconified(WindowEvent e) {}
		public void windowIconified(WindowEvent e) {}
		public void windowOpened(WindowEvent e) {}});
	    
	    

	}

}
  

