package applications.dns;

/** this has been generated by Fredy's Admin-Tool for SQL-Databases
 *  this is a Swing-Form

 *  Date: 1999-9-27
 * 
 *  Table:    hostinformation
 *  Database: dns
 *
 *  Admin is under GPL
 *
 *  Fredy Fischer
 *  Hulmenweg 36
 *  8405 Winterthur
 *  Switzerland
 *
 * se-afs@dial.eunet.ch
 *
 **/

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JPanel; 
import javax.swing.JFrame;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.awt.datatransfer.*;
import applications.basics.ButtonPanel;
import applications.basics.sqlTable;
import applications.basics.DBcomboBox;

public  class HostinformationGrid  extends JTabbedPane {

    public JTable list;
    private JPanel     listPanel;
    private JComboBox  search;
    private JCheckBox  exact;
    private JTextField searchString;

    private DBcomboBox domain;
    private DBcomboBox hostname;
    private JTextField hardware;
    private JTextField os;
    public ButtonPanel bp;



    String host;
  
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getHost() {return host;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host
       */
    public void setHost(String  v) {this.host = v;}
    
    String user;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getUser() {return user;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setUser(String  v) {this.user = v;}
    
    String password;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getPassword() {return password;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setPassword(String  v) {this.password = v;}

    public HostinformationGrid (String host, String user, String password) {

	setHost(host);
	setUser(user);
	setPassword(password);

	this.add("Form",formPanel());
	this.add("Search",searchPanel());
    }

    private JPanel formPanel() {

	domain   = new DBcomboBox(getHost(),getUser(),getPassword(),"dns","select name from domain order by name");
	domain.setSelectedIndex(0);
	domain.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		String q = "select hostname from host where domain='"+(String)domain.getSelectedItem()+ "' order by hostname";
		hostname.setQuery(q);
		hostname.setItems();
		hostname.updateUI();
	    }});

    String query = "select hostname from host where domain='"+(String)domain.getSelectedItem()+ "' order by hostname";
    hostname = new DBcomboBox(getHost(),getUser(),getPassword(),"dns",query);

    hardware = new JTextField("",25);
    os = new JTextField("",25);

	JPanel panel = new JPanel();
	panel.setLayout(new BorderLayout());
	bp = new ButtonPanel();	
	panel.add("South",bp);

	bp.insert.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		insert(getRow());
		}});
	bp.delete.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		delete(getRow());
		}});
	bp.update.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		update(getRow());
		}});
	bp.clear.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		clear();
		}});
	


	JPanel gridPanel = new JPanel();
	gridPanel.setLayout(new GridBagLayout());

	GridBagConstraints gbc;
	Insets insets = new Insets(5,5,5,5);
        JScrollPane fScrollPane;


	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Domain"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(domain,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Hostname"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(hostname,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Hardware"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(hardware,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Os"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(os,gbc);

	JScrollPane scrollpane = new JScrollPane(gridPanel);

	panel.add("Center",scrollpane);

	return panel;

    }


    private JPanel searchPanel() {

	final JPanel panel = new JPanel();
	panel.setLayout(new BorderLayout());

   final JPanel panel2 = new JPanel();
	panel2.setLayout(new FlowLayout());

	listPanel = new JPanel();

	String[] items = {        "domain",
        "hostname",
        "hardware",
        "os",
	};
	
	search = new JComboBox(items);
	exact  = new JCheckBox("exact search");
	exact.setSelected(true);
	searchString = new JTextField("",20);
	JButton doIt = new JButton("Search");
	doIt.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		String query = "select * from hostinformation where ";
		String sel   = (String)search.getSelectedItem();
		int    ind   = search.getSelectedIndex();
		query = query + sel + " ";
		if (exact.isSelected()) {
		   query = query + "  = ";
		} else { query  = query + " like "; }
	        String s = searchString.getText();
		switch (ind) {
		case 0:
		    query = query + "'" + s + "'";
		    break;
		case 1:
		    query = query + "'" + s + "'";
		    break;
		case 2:
		    query = query + "'" + s + "'";
		    break;
		case 3:
		    query = query + "'" + s + "'";
		    break;
		default:
		    ;
		}
		query = query + " order by " + sel;
		panel.remove(listPanel);
           final sqlTable st = new sqlTable(getHost(), getUser(), getPassword(),"dns",query);
		JScrollPane scp = new JScrollPane(st);
		Dimension d = new Dimension();
		d = panel.getSize();
 	        Integer intx = new Integer(d.width);
	        Integer inty = new Integer(d.height);
	        double fx = intx.floatValue() * 0.95;
	        double fy = inty.floatValue() * 0.65;
	        Double dfx = new Double(fx);
	        Double dfy = new Double(fy);
		d.setSize(dfx.intValue(),dfy.intValue());
		st.tableView.setPreferredScrollableViewportSize(d);
		listPanel = new JPanel();
		listPanel.add(scp);
		panel.add("South",listPanel);
		panel.updateUI();

		// as well there is needed a List Selection Listener
		st.tableView.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
		    public void valueChanged(ListSelectionEvent e) {
		HostinformationRow k = new HostinformationRow(getHost(), getUser(),getPassword());

			Integer i = new Integer(0);
			Float f = new Float(0);
			Double dbl = new Double(0);
			k.setDomain((String)st.tableView.getValueAt(st.tableView.getSelectedRow(),0));
			k.setHostname((String)st.tableView.getValueAt(st.tableView.getSelectedRow(),1));
			k.setHardware((String)st.tableView.getValueAt(st.tableView.getSelectedRow(),2));
			k.setOs((String)st.tableView.getValueAt(st.tableView.getSelectedRow(),3));


			setRow(k);
		    }});
		}});
	


	panel2.add(search);
	panel2.add(searchString);
	panel2.add(exact);
	panel2.add(doIt);
	panel2.setBorder(BorderFactory.createEtchedBorder());

	panel.add("North",panel2);
	panel.add("Center",listPanel);
	

	return panel;

    }


    public HostinformationRow getRow() {

        HostinformationRow k = new HostinformationRow(getHost(), getUser(), getPassword());

	k.setDomain((String)domain.getSelectedItem());
	k.setHostname((String)hostname.getSelectedItem());
	k.setHardware(hardware.getText());
	k.setOs(os.getText());
   return k;

   }


    public void insert(HostinformationRow k) { msg(k.insert()); }
    public void update(HostinformationRow k) { msg(k.update()); }
    public void delete(HostinformationRow k) { 
	String string1 = "Yes";
	String string2 = "No";
	Object[] options = {string1, string2};
	int n = JOptionPane.showOptionDialog(null,
                              "Do you really want to delete?",
                               "Delete  ?",
                              JOptionPane.YES_NO_OPTION,
                              JOptionPane.QUESTION_MESSAGE,
                              null,     //don't use a custom Icon
                              options,  //the titles of buttons
                              string2); //the title of the default button
	     if (n == JOptionPane.YES_OPTION) {
		 String s = k.delete();
		 if (s.startsWith("ok")) {
		     clear();
		 } else { msg(s);}
	     }
    }

    private void msg(String s) {
	if (  ! s.startsWith("ok") )  JOptionPane.showMessageDialog(null, s,"Message",JOptionPane.WARNING_MESSAGE);
    }

    public void clear() {
		domain.setSelectedIndex(0);
		hostname.setSelectedIndex(0);
		hardware.setText("");
		os.setText("");
    }

    public void setRow(HostinformationRow k) {

	domain.setSelectedItem(k.getDomain());
	hostname.setSelectedItem(k.getHostname());
	hardware.setText(k.getHardware());
	os.setText(k.getOs());

   }

    public static void main(String args[]) {

	if (args.length != 3) {
	    System.out.println("Syntax: java applications.dns.HostinformationGrid host user password");
	    System.exit(0);
	}
	HostinformationGrid kg = new HostinformationGrid(args[0], args[1], args[2]);
	JFrame frame = new JFrame("Hostinformation Form");
	frame.getContentPane().setLayout(new BorderLayout());
	frame.getContentPane().add("Center",kg);
	frame.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) {System.exit(0);}
            public void windowDeactivated(WindowEvent e) {}
            public void windowDeiconified(WindowEvent e) {}
            public void windowIconified(WindowEvent e) {}
            public void windowOpened(WindowEvent e) {}});
	kg.bp.cancel.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.exit(0);
		}});
	frame.pack();
	frame.setVisible(true);
	
    }
}
