package applications.dns;

/** this has been generated by Fredy's Admin-Tool for SQL-Databases
 *  Date: 1999-9-23
 * 
 *  RDBMS:    MySQL 
 *  Table:    mailexchange
 *  Database: dns
 *
 *  Admin is under GPL
 *
 *  Fredy Fischer
 *  Hulmenweg 36
 *  8405 Winterthur
 *  Switzerland
 *
 * se-afs@dial.eunet.ch
 *
 **/

import java.sql.*;
import java.util.Calendar;
import applications.basics.t_connect;

public class MailexchangeRow { 
    private  ResultSet sqlresult;
    private  t_connect con;
    
    String host;
  
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getHost() {return host;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host
       */
    public void setHost(String  v) {this.host = v;}
    
    String user;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getUser() {return user;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setUser(String  v) {this.user = v;}
    
    String password;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getPassword() {return password;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setPassword(String  v) {this.password = v;}


    String database;
    
    /**
       * Get the value of database.
       * @return Value of database.
       */
    public String getDatabase() {return database;}
    
    /**
       * Set the value of database.
       * @param v  Value to assign to database.
       */
    public void setDatabase(String  v) {this.database = v;}

       String domain;

    /**
       * Set the value of domain.
       * @param v  Value to assign to domain .
       */
       public void setDomain(String  v) { this.domain = v;}

    /**
       * Get the value of domain.
       * @return  Value of domain .
       */
       public String getDomain() {return domain;} 

       String mailexchange;

    /**
       * Set the value of mailexchange.
       * @param v  Value to assign to mailexchange .
       */
       public void setMailexchange(String  v) { this.mailexchange = v;}

    /**
       * Get the value of mailexchange.
       * @return  Value of mailexchange .
       */
       public String getMailexchange() {return mailexchange;} 

       String priority;

    /**
       * Set the value of priority.
       * @param v  Value to assign to priority .
       */
       public void setPriority(String  v) { this.priority = v;}

    /**
       * Get the value of priority.
       * @return  Value of priority .
       */
       public String getPriority() {return priority;} 

    String query;
    
    /**
       * Get the value of query.
       * @return Value of query.
       */
    public String getQuery() {return query;}
    
    /**
       * Set the value of query.
       * @param v  Value to assign to query.
       */
    public void setQuery(String  v) {this.query = v;}

    private String toDay() {

	        Calendar c = Calendar.getInstance();

    	return  Integer.toString(c.get(Calendar.YEAR)) + "-" + 
                 Integer.toString(c.get(Calendar.MONTH)+1)+ "-" + 
                 Integer.toString(c.get(Calendar.DATE));
     }
    public MailexchangeRow(String host, String user, String password) {

	setDatabase("dns");

	setHost(host);
	setUser(user);
	setPassword(password);

	setDomain("");
	setMailexchange("");
	setPriority("");


    }

    public MailexchangeRow(String host, String user, String password,String domain,String mailexchange,String priority) {

	setDatabase("dns");

	setHost(host);
	setUser(user);
	setPassword(password);

	setDomain(domain);
	setMailexchange(mailexchange);
	setPriority(priority);


    }    private String execQuery() {

	t_connect c = new t_connect(getHost(), getUser(), getPassword(), getDatabase());
	if (c.getError() != null) {
	    return "Connection Error: "+ c.getError();
	}	


        try {
	    int records = c.stmt.executeUpdate(getQuery());
	    c.close(); 	
	} catch (Exception e) {
	    return e.getMessage().toString();
	}
	return "ok";
    }

    private String selectQuery() {

	con = new t_connect(getHost(), getUser(), getPassword(), getDatabase());
	if (con.getError() != null) {
	    return "Connection Error: "+ con.getError();
	}

	try {
          sqlresult = con.stmt.executeQuery(getQuery());

	} catch (Exception e) {
	    return e.getMessage().toString();
	}
	return "ok";
    }


    public MailexchangeRow next() {

	MailexchangeRow k = new MailexchangeRow(getHost(),getUser(),getPassword());
	try {
	    if (sqlresult.next()) {
               k.setDomain(sqlresult.getString("domain"));
               k.setMailexchange(sqlresult.getString("mailexchange"));
               k.setPriority(sqlresult.getString("priority"));
		return k;
	    } else 
		{ con.close();
		  return null; 
		}
	} catch  (Exception e) {
          return null;
	}
    }
    public String insert() {

      setQuery ("insert into mailexchange (domain, mailexchange, priority) values (" +"'" + getDomain() +"'" + ", " + "'" + getMailexchange() +"'" + ", " + "'" + getPriority() +"'" + ")");  
       return execQuery();
 
    }


    public String update() {

	setQuery("update mailexchange set domain = " + "'" + getDomain() + "'" + ", mailexchange = " + "'" + getMailexchange() + "'" + ", priority = " + "'" + getPriority() + "'" + " where  (domain =  " + "'" + getDomain() + "'"  + " and mailexchange =  " + "'" + getMailexchange() + "'"  + " and priority =  " + "'" + getPriority() + "'"  + ")" );
        return execQuery();
    }


    public String delete() {

 	setQuery("delete from mailexchange where  (domain =  " + "'" + getDomain() + "'"  + " and mailexchange =  " + "'" + getMailexchange() + "'"  + " and priority =  " + "'" + getPriority() + "'"  + ")");
        return execQuery();
    }

    public String searchAll() {

 	setQuery("select * from mailexchange");
        return selectQuery();
    }

    // if you set exact to true, it will return exact the corresponding row
    // if you set exact to false,all rows corresponding  like-Statement will be returned

    public String searchByDomain(String domain, boolean exact) {

	String e;
	if ( exact ) { 
	   e = "="; } else {
	   e = "like"; }
 	setQuery("select * from mailexchange where domain " + e + " " + "'" + domain + "'" + " order by domain");
	return selectQuery();
    }


    // if you set exact to true, it will return exact the corresponding row
    // if you set exact to false,all rows corresponding  like-Statement will be returned

    public String searchByMailexchange(String mailexchange, boolean exact) {

	String e;
	if ( exact ) { 
	   e = "="; } else {
	   e = "like"; }
 	setQuery("select * from mailexchange where mailexchange " + e + " " + "'" + mailexchange + "'" + " order by mailexchange");
	return selectQuery();
    }


    // if you set exact to true, it will return exact the corresponding row
    // if you set exact to false,all rows corresponding  like-Statement will be returned

    public String searchByPriority(String priority, boolean exact) {

	String e;
	if ( exact ) { 
	   e = "="; } else {
	   e = "like"; }
 	setQuery("select * from mailexchange where priority " + e + " " + "'" + priority + "'" + " order by priority");
	return selectQuery();
    }


}
