package applications.dns;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JPanel; 
import javax.swing.JFrame;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.awt.datatransfer.*;
import applications.basics.ButtonPanel;

public class NewDomain extends JPanel {


    private JTextField name;
    private JTextField responsible;
    private JTextField serialnumber;
    private JTextField refresh;
    private JTextField retry;
    private JTextField expire;
    private JTextField minTTL;
    public ButtonPanel bp;

    String host;
  
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getHost() {return host;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host
       */
    public void setHost(String  v) {this.host = v;}
    
    String user;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getUser() {return user;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setUser(String  v) {this.user = v;}
    
    String password;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getPassword() {return password;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setPassword(String  v) {this.password = v;}


    public NewDomain(String host,  String user, String password) {

	setHost(host);
	setUser(user);
	setPassword(password);

	this.setLayout(new BorderLayout());
	this.add("Center",formPanel());

    }

    private JPanel formPanel() {
    name = new JTextField("",25);
    responsible = new JTextField("root",25);
    serialnumber = new JTextField("1",11);
    refresh = new JTextField("10800",11);
    retry = new JTextField("3600",11);
    expire = new JTextField("604800",11);
    minTTL = new JTextField("86400",11);

	JPanel panel = new JPanel();
	panel.setLayout(new BorderLayout());
	bp = new ButtonPanel();	
	panel.add("South",bp);

	bp.insert.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		insert(getRow());
		}});
	bp.delete.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		delete(getRow());
		}});
	bp.update.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		update(getRow());
		}});
	bp.clear.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		clear();
		}});
	


	JPanel gridPanel = new JPanel();
	gridPanel.setLayout(new GridBagLayout());

	GridBagConstraints gbc;
	Insets insets = new Insets(5,5,5,5);
        JScrollPane fScrollPane;


	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Domainname"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(name,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Responsible Person"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(responsible,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Serial Number"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(serialnumber,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Refresh in secs"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(refresh,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Retry after x seconds"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(retry,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Expire after x seconds"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(expire,gbc);
	gbc = new GridBagConstraints();
	gbc.anchor=GridBagConstraints.NORTHEAST;
	gbc.insets = insets;
	gridPanel.add((JLabel) new JLabel("Minimum TTL of x seconds"),gbc);
	gbc = new GridBagConstraints ();
	gbc.gridwidth = 0;
	gbc.anchor=GridBagConstraints.WEST;
	gbc.insets = insets;
        gridPanel.add(minTTL,gbc);

	JScrollPane scrollpane = new JScrollPane(gridPanel);

	panel.add("Center",scrollpane);

	return panel;
    }

    public DomainRow getRow() {

	     DomainRow k = new DomainRow(getHost(), getUser(), getPassword());

	k.setName(name.getText());
	k.setResponsible(responsible.getText());
	try {
	    k.setSerialnumber(Integer.parseInt(serialnumber.getText()));
	} catch (NumberFormatException e) { k.setSerialnumber(0); }


	try {
	    k.setRefresh(Integer.parseInt(refresh.getText()));
	} catch (NumberFormatException e) { k.setRefresh(0); }


	try {
	    k.setRetry(Integer.parseInt(retry.getText()));
	} catch (NumberFormatException e) { k.setRetry(0); }


	try {
	    k.setExpire(Integer.parseInt(expire.getText()));
	} catch (NumberFormatException e) { k.setExpire(0); }


	try {
	    k.setMinTTL(Integer.parseInt(minTTL.getText()));
	} catch (NumberFormatException e) { k.setMinTTL(0); }


   return k;

   }


    public void insert(DomainRow k) { msg(k.insert()); }
    public void update(DomainRow k) { msg(k.update()); }
    public void delete(DomainRow k) { 
	String string1 = "Yes";
	String string2 = "No";
	Object[] options = {string1, string2};
	int n = JOptionPane.showOptionDialog(null,
                              "Do you really want to delete?",
                               "Delete  ?",
                              JOptionPane.YES_NO_OPTION,
                              JOptionPane.QUESTION_MESSAGE,
                              null,     //don't use a custom Icon
                              options,  //the titles of buttons
                              string2); //the title of the default button
	     if (n == JOptionPane.YES_OPTION) {
		 String s = k.delete();
		 if (s.startsWith("ok")) {
		     clear();
		 } else { msg(s);}
	     }
    }

    private void msg(String s) {
	if (  ! s.startsWith("ok") )  JOptionPane.showMessageDialog(null, s,"Message",JOptionPane.WARNING_MESSAGE);
    }

    public void clear() {
		name.setText("");
		responsible.setText("");
		serialnumber.setText("");
		refresh.setText("");
		retry.setText("");
		expire.setText("");
		minTTL.setText("");
    }

    public void setRow(DomainRow k) {

	name.setText(k.getName());
	responsible.setText(k.getResponsible());
	serialnumber.setText(Integer.toString(k.getSerialnumber()));
	refresh.setText(Integer.toString(k.getRefresh()));
	retry.setText(Integer.toString(k.getRetry()));
	expire.setText(Integer.toString(k.getExpire()));
	minTTL.setText(Integer.toString(k.getMinTTL()));

   }    public static void main(String args[]) {

	if (args.length != 3) {
	    System.out.println("Syntax: java applications.dns.DomainGrid host user password");
	    System.exit(0);
	}
	NewDomain kg = new NewDomain(args[0], args[1], args[2]);
	JFrame frame = new JFrame("Domain Form");
	frame.getContentPane().setLayout(new BorderLayout());
	frame.getContentPane().add("Center",kg);
	frame.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) {System.exit(0);}
            public void windowDeactivated(WindowEvent e) {}
            public void windowDeiconified(WindowEvent e) {}
            public void windowIconified(WindowEvent e) {}
            public void windowOpened(WindowEvent e) {}});
	kg.bp.cancel.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.exit(0);
		}});
	frame.pack();
	frame.setVisible(true);
	
    }
}
